package DataLayer;

import FunctionLayer.Datahandler;
import edu.stanford.nlp.pipeline.StanfordCoreNLP;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.*;

public class ThreadClient {
    public ThreadClient(int port, Datahandler datahandler, StanfordCoreNLP stanfordCoreNLP, StanfordCoreNLP stanfordCoreNLPSentiment) {
        String hostIP = new settings().getHostIP();
        if (port == new settings().getHostport() || port == new settings().getHostport2()) {
            hostIP = new settings().getHostIP2();
        }
        try {
            InetAddress ipAddress = InetAddress.getByName(hostIP);//used ip's
            try (DatagramSocket serverSocket = new DatagramSocket(port)) {
                while (true) {
                    receiveAndSendPacket(serverSocket, ipAddress, port, datahandler, stanfordCoreNLP, stanfordCoreNLPSentiment);
                }
            } catch (SocketException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            }
        } catch (UnknownHostException e) {
            e.printStackTrace();
        }
    }


    private static void receiveAndSendPacket(DatagramSocket serverSocket, InetAddress ipAddress, int port,
                                             Datahandler datahandler, StanfordCoreNLP stanfordCoreNLP, StanfordCoreNLP stanfordCoreNLPSentiment) throws
            IOException {
        byte[] receiveData = new byte[4096];
        DatagramPacket receivePacket = new DatagramPacket(receiveData, receiveData.length);
        try {
            serverSocket.receive(receivePacket);
        } catch (IOException e) {
            e.printStackTrace();
        }
        String sentence = new String(receivePacket.getData(), 0,
                receivePacket.getLength());
        sentence = sentence.replace("clientmessage:", "");
        String ResponseMsg = datahandler.getResponseMsg(sentence, "", stanfordCoreNLP, stanfordCoreNLPSentiment,
                true);
        byte[] sendData = new byte[0];
        try {
            sendData = ResponseMsg.getBytes("UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        int deliver_port = 0;
        switch (port) {
            case 48475:
                deliver_port = 48470;
                break;
            case 48476:
                deliver_port = 48471;
                break;
            case 48477:
                deliver_port = 48472;
                break;
            case 48478:
                deliver_port = 48473;
                break;
        }
        DatagramPacket sendPacket = new DatagramPacket(sendData, sendData.length, ipAddress, deliver_port);
        try {
            serverSocket.send(sendPacket);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
